/* 	This program is free software; you can redistribute it and/or modify it under the terms of the
 * 	GNU Lesser General Public License as published by the Free Software Foundation; either version
 * 	3.0 of the License, or (at your option) any later version.
 *
 * 	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * 	without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * 	See the GNU Lesser General Public License for more details.
 *
 *  The full text of the license is available at http://www.gnu.org/copyleft/lesser.html
 */



#define MALLOC(t,n) ((t*)mal((size_t)(sizeof(t) * (n))))
#define FREE(a) free(a)
#define infty (1e20)
#define epsilon (1e-8)
#define greaterp(x,y) ((x) > (y) + epsilon)
#define zerop(x) (-epsilon <= (x) && (x) <= epsilon)
#define UPPERBOUND 32767

#define push1(x,h) ((x) -> next = (h), (h) = (x))
#define pop1(x,h) ((x) = (h), (h) = (h) -> next)

typedef enum {unlabeled, odd, even} labeltyp; /* vertex label */

typedef struct vertex { /* record for vertex and shrunken blossom */
	struct vertex *base; /* base vertex of blossom (NULL if it is a vertex) */
	struct vertex *parent; /* parent blossom (NULL if it is outermost) */
	struct vertex *root; /* outermost blossom (itself if it is outermost) */
	struct vertex *round_blossom; /* round vertex in a blossom */
	struct vertex *next; /* for stack */
	struct vertex *partner; /* partner vertex (NULL if it is unmatched) */
	struct vertex *prev_tail; /* tail of previous edge */
	struct vertex *prev_head; /* head of previous edge */
	double var; /* dual variable */
	struct adj *adj_list; /* head of adjacency list */
	data_type *item; /* vertex number */
	labeltyp label; /* vertex label */
} vertex_type;

typedef struct adj { /* record for adjacency list */
	struct adj *next; /* next */
	struct vertex *head_vertex;	/* head vertex */
	double weight; /* edge weight */
} adj_type;


#define SHIFT(w) (((num / 2) * ((double)diam)) - (w) + 1)
/* defines for complete matching */
#ifdef COMPLETEMATCH
#define LOOP(p,q) for (q = v + (n - 1); q >= v; --q) {
#define END }
#define WEIGHT(p,q) (SHIFT(dist(p -> item, q -> item)))
#define ADJ(p,q) (dist(p -> item, q -> item) <= UPPERBOUND)
#endif

/* defines for k-neighbor matching */
#ifdef KNEIBMATCH
#define LOOP(p,q) { adj_type *aa; for (aa = p -> adj_list; aa != NULL; aa = aa -> next) { q = aa -> head_vertex; 
#define END }}
#define WEIGHT(p,q) (aa -> weight)
#define ADJ(p,q) (aa -> weight >= shiftbound)
#endif
